/*
 * incubus.dll for XiRCON 1.0 beta4
 * 
 * Base code stolen from falcon.dll
 *
 * 
 */

/*
 *** xtcl.dll exports ***
 *
 * _Tcl_AppendElement
 * _Tcl_AppendResult
 * _Tcl_CreateCommand
 * _Tcl_CreateInterp
 * _Tcl_DeleteCommand
 * _Tcl_DeleteInterp
 * _Tcl_DoOneEvent
 * _Tcl_Eval
 * _Tcl_EvalFile
 * _Tcl_GetVar
 * _Tcl_GlobalEval
 */

#define STRICT
#define WIN32_LEAN_AND_MEAN
#define CMD_INI
#define CMD_FILEOPEN
#define _IAL_
#define MATCH

#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <windows.h>
#include <shellapi.h>

#ifdef CMD_FILEOPEN
# include <commdlg.h>
# include <cderr.h>
#endif

#include "incubus.h"
#include "match.h"
#include "misc.h"
#include "users.h"
#include "servers.h"
#ifdef _IAL_
#include "ial.h"
#endif /* _IAL_ */

/* Globals */

HANDLE hInstance;
HANDLE hXircTcl;
int refcount=0;
dyn_CreateCommand *Tcl_CreateCommand;
dyn_AppendResult *Tcl_AppendResult;
dyn_AppendElement *Tcl_AppendElement;
dyn_GetVar *Tcl_GetVar;
dyn_Eval *Tcl_Eval;
OPENFILENAME ofn;			/* common dialog box structure   */
USER users;
USER bots;
SERVER servers;
IAL_HEAD ial_head;
int usersread;
int serversread;
char staticwork[4096];

BOOL WINAPI DllMain(HANDLE hInst, ULONG ulReason, LPVOID lpReserved) {
	switch(ulReason) {
	case DLL_PROCESS_ATTACH:
		refcount++;
		if (refcount==1)
		{
			hInstance=hInst; /* save instance handle */
			hXircTcl=GetModuleHandle("xircntcl.dll");             // beta1
			if (!hXircTcl) hXircTcl=GetModuleHandle("xtcl.dll");  // if not beta1 then try beta2
			if (!hXircTcl) hXircTcl=GetModuleHandle("tcl76.dll"); // if not beta2 try try tcl76
			if (!hXircTcl) hXircTcl=GetModuleHandle("tcl80.dll"); // .....
			if (hXircTcl)
			{
				Tcl_CreateCommand=(dyn_CreateCommand *)GetProcAddress(hXircTcl,"_Tcl_CreateCommand");
				Tcl_AppendResult=(dyn_AppendResult *)GetProcAddress(hXircTcl,"_Tcl_AppendResult");
				Tcl_AppendElement=(dyn_AppendElement *)GetProcAddress(hXircTcl,"_Tcl_AppendElement");
				Tcl_GetVar=(dyn_GetVar *)GetProcAddress(hXircTcl,"_Tcl_GetVar");
				Tcl_Eval=(dyn_Eval *)GetProcAddress(hXircTcl,"_Tcl_Eval");
			} else {
				Tcl_CreateCommand=NULL;
				Tcl_AppendResult=NULL;
				Tcl_AppendElement=NULL;
				Tcl_GetVar=NULL;
				Tcl_Eval=NULL;
			}
			// place init code here
			
			/* Set the members of the OPENFILENAME structure. */ 
			ofn.lStructSize = sizeof(OPENFILENAME);
			ofn.lpstrFileTitle = NULL; 
			ofn.lpstrDefExt = NULL;

			usersread = 0;
			serversread = 0;
			users = NULL;
			bots = NULL;
			servers = NULL;
			ial_head = NULL;
		}
		break;
	case DLL_PROCESS_DETACH:
		refcount--;
		break;
	}
	return TRUE; /* successful load */
}

char *Tcl_SetVar(void *interp, char *varname, char *newvalue)
{
	static char *workspace = NULL;
	char *temp;
	int memsize = 0, blah, idx;

	if(newvalue)
	{
		for(blah = 0; newvalue[blah] != '\0'; blah++)
		{
			if(newvalue[blah] == '[' || newvalue[blah] == ']' ||
				newvalue[blah] == '"' || newvalue[blah] == '\\')
				memsize++;
		}
	}

	if(workspace)
		free(workspace);

	if((workspace = (char *)malloc(strlen(varname)+(newvalue?(strlen(newvalue)+memsize):0)+8)) == NULL)
		return NULL;

	if(!memsize)
		sprintf(workspace, "set %s \"%s\"", varname, newvalue?newvalue:"");
	else
	{
		sprintf(workspace, "set %s \"", varname);
		idx = strlen(workspace);

		for(blah = 0; newvalue[blah] != '\0'; blah++, idx++)
		{
			if(newvalue[blah] == '[' || newvalue[blah] == ']' ||
				newvalue[blah] == '"' || newvalue[blah] == '\\')
			{
				workspace[idx] = '\\';
				idx++;
			}

			workspace[idx] = newvalue[blah];
		}
		workspace[idx] = '\"';
		workspace[idx+1] = '\0';
	}

	(*Tcl_Eval)(interp, workspace);
	return newvalue;
}

char
Tcl_Backslash(src, readPtr)
    char *src;			/* Points to the backslash character of
				 * a backslash sequence. */
    int *readPtr;		/* Fill in with number of characters read
				 * from src, unless NULL. */
{
    register char *p = src+1;
    char result;
    int count;

    count = 2;

    switch (*p) {
	/*
	 * Note: in the conversions below, use absolute values (e.g.,
	 * 0xa) rather than symbolic values (e.g. \n) that get converted
	 * by the compiler.  It's possible that compilers on some
	 * platforms will do the symbolic conversions differently, which
	 * could result in non-portable Tcl scripts.
	 */

	case 'a':
	    result = 0x7;
	    break;
	case 'b':
	    result = 0x8;
	    break;
	case 'f':
	    result = 0xc;
	    break;
	case 'n':
	    result = 0xa;
	    break;
	case 'r':
	    result = 0xd;
	    break;
	case 't':
	    result = 0x9;
	    break;
	case 'v':
	    result = 0xb;
	    break;
	case 'x':
	    if (isxdigit(p[1]))
		{
			char *end;

			result = (char) strtoul(p+1, &end, 16);
			count = end - src;
	    }
		else
		{
			count = 2;
			result = 'x';
	    }
	    break;
	case '\n':
	    do {
		p++;
	    } while ((*p == ' ') || (*p == '\t'));
	    result = ' ';
	    count = p - src;
	    break;
	case 0:
	    result = '\\';
	    count = 1;
	    break;
	default:
	    if (isdigit(*p))
		{
			result = (char)(*p - '0');
			p++;
			if (!isdigit(*p))
			{
				break;
			}
			count = 3;
			result = (char)((result << 3) + (*p - '0'));
			p++;
			if (!isdigit(*p))
			{
			    break;
			}
			count = 4;
			result = (char)((result << 3) + (*p - '0'));
			break;
	    }
	    result = *p;
	    count = 2;
	    break;
    }

    if (readPtr != NULL) {
	*readPtr = count;
    }
    return result;
}
/*
 *----------------------------------------------------------------------
 *
 * Tcl_ScanElement --
 *
 *	This procedure is a companion procedure to Tcl_ConvertElement.
 *	It scans a string to see what needs to be done to it (e.g.
 *	add backslashes or enclosing braces) to make the string into
 *	a valid Tcl list element.
 *
 * Results:
 *	The return value is an overestimate of the number of characters
 *	that will be needed by Tcl_ConvertElement to produce a valid
 *	list element from string.  The word at *flagPtr is filled in
 *	with a value needed by Tcl_ConvertElement when doing the actual
 *	conversion.
 *
 * Side effects:
 *	None.
 *
 *----------------------------------------------------------------------
 */

int
Tcl_ScanElement(string, flagPtr)
    char *string;		/* String to convert to Tcl list element. */
    int *flagPtr;		/* Where to store information to guide
				 * Tcl_ConvertElement. */
{
    int flags, nestingLevel;
    register char *p;

    /*
     * This procedure and Tcl_ConvertElement together do two things:
     *
     * 1. They produce a proper list, one that will yield back the
     * argument strings when evaluated or when disassembled with
     * Tcl_SplitList.  This is the most important thing.
     * 
     * 2. They try to produce legible output, which means minimizing the
     * use of backslashes (using braces instead).  However, there are
     * some situations where backslashes must be used (e.g. an element
     * like "{abc": the leading brace will have to be backslashed.  For
     * each element, one of three things must be done:
     *
     * (a) Use the element as-is (it doesn't contain anything special
     * characters).  This is the most desirable option.
     *
     * (b) Enclose the element in braces, but leave the contents alone.
     * This happens if the element contains embedded space, or if it
     * contains characters with special interpretation ($, [, ;, or \),
     * or if it starts with a brace or double-quote, or if there are
     * no characters in the element.
     *
     * (c) Don't enclose the element in braces, but add backslashes to
     * prevent special interpretation of special characters.  This is a
     * last resort used when the argument would normally fall under case
     * (b) but contains unmatched braces.  It also occurs if the last
     * character of the argument is a backslash or if the element contains
     * a backslash followed by newline.
     *
     * The procedure figures out how many bytes will be needed to store
     * the result (actually, it overestimates).  It also collects information
     * about the element in the form of a flags word.
     */

    nestingLevel = 0;
    flags = 0;
    if (string == NULL) {
	string = "";
    }
    p = string;
    if ((*p == '{') || (*p == '"') || (*p == 0)) {
	flags |= USE_BRACES;
    }
    for ( ; *p != 0; p++) {
	switch (*p) {
	    case '{':
		nestingLevel++;
		break;
	    case '}':
		nestingLevel--;
		if (nestingLevel < 0) {
		    flags |= TCL_DONT_USE_BRACES|BRACES_UNMATCHED;
		}
		break;
	    case '[':
	    case '$':
	    case ';':
	    case ' ':
	    case '\f':
	    case '\n':
	    case '\r':
	    case '\t':
	    case '\v':
		flags |= USE_BRACES;
		break;
	    case '\\':
		if ((p[1] == 0) || (p[1] == '\n')) {
		    flags = TCL_DONT_USE_BRACES;
		} else {
		    int size;

		    (void) Tcl_Backslash(p, &size);
		    p += size-1;
		    flags |= USE_BRACES;
		}
		break;
	}
    }
    if (nestingLevel != 0) {
	flags = TCL_DONT_USE_BRACES | BRACES_UNMATCHED;
    }
    *flagPtr = flags;

    /*
     * Allow enough space to backslash every character plus leave
     * two spaces for braces.
     */

    return 2*(p-string) + 2;
}

/*
 *----------------------------------------------------------------------
 *
 * Tcl_ConvertElement --
 *
 *	This is a companion procedure to Tcl_ScanElement.  Given the
 *	information produced by Tcl_ScanElement, this procedure converts
 *	a string to a list element equal to that string.
 *
 * Results:
 *	Information is copied to *dst in the form of a list element
 *	identical to src (i.e. if Tcl_SplitList is applied to dst it
 *	will produce a string identical to src).  The return value is
 *	a count of the number of characters copied (not including the
 *	terminating NULL character).
 *
 * Side effects:
 *	None.
 *
 *----------------------------------------------------------------------
 */

int
Tcl_ConvertElement(src, dst, flags)
    register char *src;		/* Source information for list element. */
    char *dst;			/* Place to put list-ified element. */
    int flags;			/* Flags produced by Tcl_ScanElement. */
{
    register char *p = dst;

    /*
     * See the comment block at the beginning of the Tcl_ScanElement
     * code for details of how this works.
     */

    if ((src == NULL) || (*src == 0)) {
	p[0] = '{';
	p[1] = '}';
	p[2] = 0;
	return 2;
    }
    if ((flags & USE_BRACES) && !(flags & TCL_DONT_USE_BRACES)) {
	*p = '{';
	p++;
	for ( ; *src != 0; src++, p++) {
	    *p = *src;
	}
	*p = '}';
	p++;
    } else {
	if (*src == '{') {
	    /*
	     * Can't have a leading brace unless the whole element is
	     * enclosed in braces.  Add a backslash before the brace.
	     * Furthermore, this may destroy the balance between open
	     * and close braces, so set BRACES_UNMATCHED.
	     */

	    p[0] = '\\';
	    p[1] = '{';
	    p += 2;
	    src++;
	    flags |= BRACES_UNMATCHED;
	}
	for (; *src != 0 ; src++) {
	    switch (*src) {
		case ']':
		case '[':
		case '$':
		case ';':
		case ' ':
		case '\\':
		case '"':
		    *p = '\\';
		    p++;
		    break;
		case '{':
		case '}':
		    /*
		     * It may not seem necessary to backslash braces, but
		     * it is.  The reason for this is that the resulting
		     * list element may actually be an element of a sub-list
		     * enclosed in braces (e.g. if Tcl_DStringStartSublist
		     * has been invoked), so there may be a brace mismatch
		     * if the braces aren't backslashed.
		     */

		    if (flags & BRACES_UNMATCHED) {
			*p = '\\';
			p++;
		    }
		    break;
		case '\f':
		    *p = '\\';
		    p++;
		    *p = 'f';
		    p++;
		    continue;
		case '\n':
		    *p = '\\';
		    p++;
		    *p = 'n';
		    p++;
		    continue;
		case '\r':
		    *p = '\\';
		    p++;
		    *p = 'r';
		    p++;
		    continue;
		case '\t':
		    *p = '\\';
		    p++;
		    *p = 't';
		    p++;
		    continue;
		case '\v':
		    *p = '\\';
		    p++;
		    *p = 'v';
		    p++;
		    continue;
	    }
	    *p = *src;
	    p++;
	}
    }
    *p = '\0';
    return p-dst;
}

/*
 *----------------------------------------------------------------------
 *
 * Tcl_Merge --
 *
 *	Given a collection of strings, merge them together into a
 *	single string that has proper Tcl list structured (i.e.
 *	Tcl_SplitList may be used to retrieve strings equal to the
 *	original elements, and Tcl_Eval will parse the string back
 *	into its original elements).
 *
 * Results:
 *	The return value is the address of a dynamically-allocated
 *	string containing the merged list.
 *
 * Side effects:
 *	None.
 *
 *----------------------------------------------------------------------
 */

char *
Tcl_Merge(argc, argv)
    int argc;			/* How many strings to merge. */
    char **argv;		/* Array of string values. */
{
#   define LOCAL_SIZE 20
    int localFlags[LOCAL_SIZE], *flagPtr;
    int numChars;
    char *result;
    register char *dst;
    int i;

    /*
     * Pass 1: estimate space, gather flags.
     */

    if (argc <= LOCAL_SIZE) {
	flagPtr = localFlags;
    } else {
	flagPtr = (int *) malloc((unsigned) argc*sizeof(int));
    }
    numChars = 1;
    for (i = 0; i < argc; i++) {
	numChars += Tcl_ScanElement(argv[i], &flagPtr[i]) + 1;
    }

    /*
     * Pass two: copy into the result area.
     */

    result = (char *) malloc((unsigned) numChars);
    dst = result;
    for (i = 0; i < argc; i++) {
	numChars = Tcl_ConvertElement(argv[i], dst, flagPtr[i]);
	dst += numChars;
	*dst = ' ';
	dst++;
    }
    if (dst == result) {
	*dst = 0;
    } else {
	dst[-1] = 0;
    }

    if (flagPtr != localFlags) {
	free((char *) flagPtr);
    }
    return result;
}

#ifdef CMD_INI
/* ini read/write funtion */
int CmdIni(void *cd,void *interp,int argc,char *argv[])
{
	char rcvbuff[256]= {'\0'}; DWORD err;

	// the only error checking going on here is checking for command
	// and arg count. do i need more??? i think so , but what???

	if(argc < 2)
	{
		(*Tcl_AppendResult)(interp,"Usage: ", argv[0], " -write/-read parameters",NULL);
		return TCL_ERROR;
	}

	if (!strnicmp(argv[1],"-r",2))
	{
		if (argc==6)
		{
			if(GetPrivateProfileString(argv[3],argv[4],argv[5],rcvbuff,255,argv[2])!=255)
			{
				(*Tcl_AppendResult)(interp,rcvbuff,NULL);
				return TCL_OK;
			}
			else
			{
				// a tiny error check for data length
				(*Tcl_AppendResult)(interp,"ini data is larger than 255 characters!",NULL);
				return TCL_ERROR;
			}
		}
		else
		{
			(*Tcl_AppendResult)(interp,"Usage: ", argv[0], " -read inifile section key default; returns data from ini file",NULL);
			return TCL_ERROR;
		}
	}
	
	if (!strnicmp(argv[1],"-w",2))
	{
		if (argc==6)
		{
			if (WritePrivateProfileString(argv[3],argv[4],argv[5],argv[2])==TRUE)
			{
				(*Tcl_AppendResult)(interp,"0",NULL); //returns zero on success
				return TCL_OK;
			}
			else
			{
				switch (err=GetLastError())
				{
					case 3 :(*Tcl_AppendResult)(interp,"Path Not Found!",NULL); break;
					default : {
						strcat(_itoa(err,rcvbuff,10)," error writing to file!");
						(*Tcl_AppendResult)(interp,rcvbuff,NULL);
					}
				}
				return TCL_ERROR;  
			}
		}
		else
		{
			(*Tcl_AppendResult)(interp,"Usage: ", argv[0], " -write inifile section key string; returns: 0 on success, system error msg on failure",NULL);
			return TCL_ERROR;
		}
	}

	if (!strnicmp(argv[1],"-delkey", 7))
	{
		if (argc == 5)
		{
			if (WritePrivateProfileString(argv[3],argv[4],NULL,argv[2])==TRUE)
			{
				(*Tcl_AppendResult)(interp,"0",NULL); //returns zero on success
				return TCL_OK;
			}
			else
			{
				switch (err=GetLastError())
				{
					case 3 :(*Tcl_AppendResult)(interp,"Path Not Found!",NULL); break;
					default : {
						strcat(_itoa(err,rcvbuff,10)," error writing to file!");
						(*Tcl_AppendResult)(interp,rcvbuff,NULL);
					}
				}
				return TCL_ERROR;  
			}
		}
		else
		{
			(*Tcl_AppendResult)(interp,"Usage: ", argv[0], " -delkey inifile section key; returns: 0 on success, system error msg on failure",NULL);
			return TCL_ERROR;
		}
	}

	if (!strnicmp(argv[1],"-delsection", 11))
	{
		if (argc == 4)
		{
			if (WritePrivateProfileString(argv[3],NULL,NULL,argv[2])==TRUE)
			{
				(*Tcl_AppendResult)(interp,"0",NULL); //returns zero on success
				return TCL_OK;
			}
			else
			{
				switch (err=GetLastError())
				{
					case 3 :(*Tcl_AppendResult)(interp,"Path Not Found!",NULL); break;
					default : {
						strcat(_itoa(err,rcvbuff,10)," error writing to file!");
						(*Tcl_AppendResult)(interp,rcvbuff,NULL);
					}
				}
				return TCL_ERROR;  
			}
		}
		else
		{
			(*Tcl_AppendResult)(interp,"Usage: ", argv[0], " -delsection inifile section; returns: 0 on success, system error msg on failure",NULL);
			return TCL_ERROR;
		}
	}

	(*Tcl_AppendResult)(interp,"Usage: ", argv[0], " -write/-read/-delkey/-delsection parameters",NULL);
	return TCL_ERROR;
}
#endif //#ifdef CMD_INI


#ifdef MATCH
int CmdWild_match(void *cd,void *interp,int argc,unsigned char *argv[])
{
	register unsigned char *m=argv[1], *n=argv[2];

	if (argc!=3)
	{
	  (*Tcl_AppendResult)(interp,"Usage: ", argv[0], " Pattern String; returns: 0 for nomatch, or 1 for match",NULL);
		return TCL_ERROR;
	}

	if(_match(argv[1], argv[2]))
	{
		(*Tcl_AppendResult)(interp, "0", NULL);
	}
	else
	{
		(*Tcl_AppendResult)(interp, "1", NULL);
	}
	return TCL_OK;
}
#endif //#ifdef MATCH


#ifdef CMD_FILEOPEN
/*
 * function: Cmdfile_open
 * purpose:  opens a 'fileopen common dialog' and returns the fullpath
 *           of the selected file.
 *
 * Usage: file_open [-m] <Title> <defaultDir> <filter>
 *
 * Tcl example: 
 *   /tcl echo [file_open -m "Send what text to channel?" "c:/windows" "Text File|*.txt;*.asc|All Files|*.*|"]
 *
 *   switches: -m   the dialog will be app-modal to XiRCON 1.0B2
 *                  Tclsh and other versions not supported yet.
 *                  DNU -m if not 1.0B2! i will fix this when B3 comes out.
 */
int Cmdfile_open(void *cd,void *interp,int argc,char *argv[])
{
	char szFile[260];						  /* filename string */ 
	int i,j=1; DWORD er;
	char buff[800]={'\0'};

	//_itoa(argc,buff,10);
	//(*Tcl_AppendResult)(interp,buff,NULL);
	//return TCL_OK;

	if (argc>2) {

		/* Check for modal flag */
		if(!stricmp(argv[j],"-m")){ j++; ofn.hwndOwner = FindWindow(NULL,"XiRCON 1.0B2"); }
		else ofn.hwndOwner = NULL; 

		/* set the title */
		ofn.lpstrTitle = argv[j++];

		/* load default directory and replaces "/" with "\" */
		for(i=0;argv[j][i]!='\0';i++) 
			if(argv[j][i]=='/')argv[j][i]='\\';
		ofn.lpstrInitialDir = argv[j++]; 
		
		/* Load the filter string and replace '|'s with NULLs */		
		for(i=0;argv[j][i]!='\0';i++) 
			if(argv[j][i]=='|')argv[j][i]='\0';
		ofn.lpstrFilter = argv[j++]; 
		ofn.nFilterIndex = 1; 

		/* Place the terminating null character in szFile. */ 
		szFile[0] = '\0'; 
		ofn.lpstrFile = szFile;
		ofn.nMaxFile = sizeof(szFile); 
		
		ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_LONGNAMES;
		
		/* Display the Open dialog box. */ 
		if (GetOpenFileName(&ofn)) { 
			(*Tcl_AppendResult)(interp, ofn.lpstrFile, NULL);
			return TCL_OK;
		} else {
			switch (er=CommDlgExtendedError()) {
				case CCERR_CHOOSECOLORCODES	: strcpy(buff,"Error codes for the Color common dialog box. these errors are in the range 0x5000 through 0x5FFF.");break;
				case CDERR_DIALOGFAILURE    : strcpy(buff,"The common dialog box procedure's call to the DialogBox function failed. For example, this error occurs if the common dialog box call specifies an invalid window handle.");break;
				case CDERR_FINDRESFAILURE	  : strcpy(buff,"The common dialog box procedure failed to find a specified resource!");break;
				case CDERR_GENERALCODES:
					(*Tcl_AppendResult)(interp, "", NULL);
					return TCL_OK;
					break;
				case CDERR_INITIALIZATION	  : strcpy(buff,"The common dialog box procedure failed during initialization. This error often occurs when insufficient memory is available.");break;
				case CDERR_LOADRESFAILURE	  : strcpy(buff,"The common dialog box procedure failed to load a specified resource.");break;
				case CDERR_LOADSTRFAILURE	  : strcpy(buff,"The common dialog box procedure failed to load a specified string.");break;
				case CDERR_LOCKRESFAILURE   : strcpy(buff,"The common dialog box procedure failed to lock a specified resource.");break;
				case CDERR_MEMALLOCFAILURE  : strcpy(buff,"The common dialog box procedure was unable to allocate memory for internal structures.");break;
				case CDERR_MEMLOCKFAILURE   : strcpy(buff,"The common dialog box procedure was unable to lock the memory associated with a handle.");break;
				case CDERR_NOHINSTANCE      : strcpy(buff,"The ENABLETEMPLATE flag was specified in the Flags member of a structure for the corresponding common dialog box, but the application failed to provide a corresponding instance handle.");break;
				case CDERR_NOHOOK           : strcpy(buff,"The ENABLEHOOK flag was specified in the Flags member of a structure for the corresponding common dialog box, but the application failed to provide a pointer to a corresponding hook function.");break;
				case CDERR_NOTEMPLATE       : strcpy(buff,"The ENABLETEMPLATE flag was specified in the Flags member of a structure for the corresponding common dialog box, but the application failed to provide a corresponding template.");break;
				case CDERR_REGISTERMSGFAIL  : strcpy(buff,"The RegisterWindowMessage function returned an error code when it was called by the common dialog box procedure.");break;
				case CDERR_STRUCTSIZE       : strcpy(buff,"The lStructSize member of a structure for the corresponding common dialog box is invalid.");break;
				case CFERR_CHOOSEFONTCODES  : strcpy(buff,"Error codes for the Font common dialog box. These errors are in the range 0x2000 through 0x2FFF.");break;
				case CFERR_MAXLESSTHANMIN   : strcpy(buff,"The size specified in the nSizeMax member of the CHOOSEFONT structure is less than the size specified in the nSizeMin member.");break;
				case CFERR_NOFONTS          : strcpy(buff,"No fonts exist.");break;
				case FNERR_BUFFERTOOSMALL   : strcpy(buff,"The buffer for a filename is too small. (This buffer is pointed to by the lpstrFile member of the structure for a common dialog box.)");break;
				case FNERR_FILENAMECODES    : strcpy(buff,"Error codes for the Open and Save As common dialog boxes. these errors are in the range 0x3000 through 0x3FFF.");break;
				case FNERR_INVALIDFILENAME  : strcpy(buff,"A filename is invalid.");break;
				case FNERR_SUBCLASSFAILURE  : strcpy(buff,"An attempt to subclass a list box failed because insufficient memory was available.");break;
				case FRERR_BUFFERLENGTHZERO : strcpy(buff,"A member in a structure for the corresponding common dialog box points to an invalid buffer.");break;
				case FRERR_FINDREPLACECODES : strcpy(buff,"Error codes for the Find and Replace common dialog boxes. these errors are in the range 0x4000 through 0x4FFF.");break;
				case PDERR_CREATEICFAILURE	: strcpy(buff,"The PrintDlg function failed when it attempted to create an information context.");break;
				case PDERR_DEFAULTDIFFERENT	: strcpy(buff,"An application called the PrintDlg function with the DN_DEFAULTPRN flag specified in the wDefault member of the DEVNAMES structure, but the printer described by the other structure members did not match the current default printer. (This error happens when an application stores the DEVNAMES structure and the user changes the default printer by using Control Panel.)	To use the printer described by the DEVNAMES structure, the application should clear the DN_DEFAULTPRN flag and call the PrintDlg function again. To use the default printer, the application should replace the DEVNAMES structure (and the DEVMODE structure, if one exists) with NULL; this sets the default printer automatically.");break;
				case PDERR_DNDMMISMATCH     : strcpy(buff,"The data in the DEVMODE and DEVNAMES structures describes two different printers.");break;
				case PDERR_GETDEVMODEFAIL   : strcpy(buff,"The printer driver failed to initialize a DEVMODE structure. (This error code applies only to printer drivers written for Windows versions 3.0 and later.)");break;
				case PDERR_INITFAILURE      : strcpy(buff,"The PrintDlg function failed during initialization, and there is no more specific extended error code to describe the failure. This is the generic default error code for the function.");break;
				case PDERR_LOADDRVFAILURE   : strcpy(buff,"The PrintDlg function failed to load the device driver for the specified printer.");break;
				case PDERR_NODEFAULTPRN     : strcpy(buff,"A default printer does not exist.");break;
				case PDERR_NODEVICES        : strcpy(buff,"No printer drivers were found.");break;
				case PDERR_PARSEFAILURE     : strcpy(buff,"The PrintDlg function failed to parse the strings in the [devices] section of the WIN.INI file.");break;
				case PDERR_PRINTERCODES     : strcpy(buff,"Error codes for the Print common dialog box. These errors are in the range 0x1000 through 0x1FFF.");break;
				case PDERR_PRINTERNOTFOUND  : strcpy(buff,"The [devices] section of the WIN.INI file did not contain an entry for the requested printer.");break;
				case PDERR_RETDEFFAILURE    : strcpy(buff,"The PD_RETURNDEFAULT flag was specified in the Flags member of the PRINTDLG structure, but the hDevMode or hDevNames member was nonzero.");break;
				case PDERR_SETUPFAILURE     : strcpy(buff,"The PrintDlg function failed to load the required resources.");break;
				default :_ltoa(er,buff,10);
			}
			strcat(buff,"; GetOpenFileName() returned false!");
			(*Tcl_AppendResult)(interp,buff,NULL);
			return TCL_ERROR;
		}
	} else {
		/* arg count is wrong */
		(*Tcl_AppendResult)(interp, "Usage: ", argv[0], " ?-m? Title DefaultDir filter : returns the fullpath of the file selected", NULL);
		return TCL_ERROR;
	}
}
#endif  // #ifdef CMD_FILEOPEN

int CmdStrlen(void *cd,void *interp,int argc,unsigned char *argv[])
{
	char buf[256];

	if (argc!=2)
	{
	  (*Tcl_AppendResult)(interp,"Usage: ", argv[0], " String; returns: length of string",NULL);
		return TCL_ERROR;
	}

	(*Tcl_AppendResult)(interp, itoa(strlen(argv[1]), buf, 10), NULL);
	return TCL_OK;
}

int CmdStrcmp(void *cd,void *interp,int argc,unsigned char *argv[])
{
	char buf[256];

	if (argc!=3)
	{
	  (*Tcl_AppendResult)(interp,"Usage: ", argv[0], " String1 String2; returns: 0 for nomatch, or 1 for match",NULL);
		return TCL_ERROR;
	}

	(*Tcl_AppendResult)(interp, itoa(strcmp(argv[1], argv[2]), buf, 10), NULL);
	return TCL_OK;
}

int CmdStrncmp(void *cd,void *interp,int argc,unsigned char *argv[])
{
	char buf[256];

	if (argc!=4)
	{
	  (*Tcl_AppendResult)(interp,"Usage: ", argv[0], " String1 String2 Length; returns: 0 for nomatch, or 1 for match",NULL);
		return TCL_ERROR;
	}

	(*Tcl_AppendResult)(interp, itoa(strncmp(argv[1], argv[2], atoi(argv[3])), buf, 10), NULL);
	return TCL_OK;
}

int CmdStricmp(void *cd,void *interp,int argc,unsigned char *argv[])
{
	char buf[256];

	if (argc!=3)
	{
	  (*Tcl_AppendResult)(interp,"Usage: ", argv[0], " String1 String2; returns: 0 for nomatch, or 1 for match",NULL);
		return TCL_ERROR;
	}

	(*Tcl_AppendResult)(interp, itoa(stricmp(argv[1], argv[2]), buf, 10), NULL);
	return TCL_OK;
}

int CmdStrnicmp(void *cd,void *interp,int argc,unsigned char *argv[])
{
	char buf[256];

	if (argc!=4)
	{
	  (*Tcl_AppendResult)(interp,"Usage: ", argv[0], " String1 String2 Length; returns: 0 for nomatch, or 1 for match",NULL);
		return TCL_ERROR;
	}

	(*Tcl_AppendResult)(interp, itoa(strnicmp(argv[1], argv[2], atoi(argv[3])), buf, 10), NULL);
	return TCL_OK;
}

int CmdReadusers(void *cd,void *interp,int argc,unsigned char *argv[])
{
	char blah[3];

	if (argc!=2)
	{
	  (*Tcl_AppendResult)(interp,"Usage: ", argv[0], " Filename; returns: 0 if users have already been read, -1 if <Filename> cannot be opened, and 1 if read was successful",NULL);
		return TCL_ERROR;
	}

	(*Tcl_AppendResult)(interp, itoa(read_user_file(argv[1]), blah, 10), NULL);
	return TCL_OK;
}

int CmdWriteusers(void *cd,void *interp,int argc,unsigned char *argv[])
{
	char blah[3];

	if (argc!=2)
	{
	  (*Tcl_AppendResult)(interp,"Usage: writeusers Filename; returns: 0 if users haven't been read yet, -1 if <Filename> cannot be opened, and 1 if write was successful",NULL);
		return TCL_ERROR;
	}

	(*Tcl_AppendResult)(interp, itoa(write_user_file(argv[1]), blah, 10), NULL);
	return TCL_OK;
}

int CmdAdduser(void *cd,void *interp,int argc,unsigned char *argv[])
{
	int blah;

	if (argc!=4)
	{
	  (*Tcl_AppendResult)(interp,"Usage: ", argv[0], " Network Mask Flags",NULL);
		return TCL_ERROR;
	}

	for (blah = 0; argv[3][blah] != '\0'; blah++)
	{
		if(argv[3][blah] < '0' || argv[3][blah] > '9')
		{
			(*Tcl_AppendResult)(interp,"non-numeric value for Flags; Usage: ", argv[0], " Network Mask Flags",NULL);
			return TCL_ERROR;
		}
	}

	if((blah = atoi(argv[3])) == 0)
	{
		(*Tcl_AppendResult)(interp,"<Flags> must not be zero; Usage: ", argv[0], " Network Mask Flags",NULL);
		return TCL_ERROR;
	}

	adduser(argv[1], argv[2], blah, NULL);
	usersread = 1;
	(*Tcl_AppendResult)(interp, "", NULL);
	return TCL_OK;
}

int CmdAddbot(void *cd,void *interp,int argc,unsigned char *argv[])
{
	int blah;

	if (argc!=5)
	{
	  (*Tcl_AppendResult)(interp,"Usage: ", argv[0], " Network Mask Flags Password",NULL);
		return TCL_ERROR;
	}

	for (blah = 0; argv[3][blah] != '\0'; blah++)
	{
		if(argv[3][blah] < '0' || argv[3][blah] > '9')
		{
			(*Tcl_AppendResult)(interp,"non-numeric value for Flags; Usage: ", argv[0], " Network Mask Flags Password",NULL);
			return TCL_ERROR;
		}
	}

	if((blah = atoi(argv[3])) == 0)
	{
		(*Tcl_AppendResult)(interp,"Flags must not be zero; Usage: ", argv[0], " Network Mask Flags Password",NULL);
		return TCL_ERROR;
	}

	adduser(argv[1], argv[2], blah, argv[4]);
	usersread = 1;
	(*Tcl_AppendResult)(interp, "", NULL);
	return TCL_OK;
}

int CmdClearusers(void *cd,void *interp,int argc,unsigned char *argv[])
{

	if(usersread)
	{
		clear_all_users();
		usersread = 0;
		(*Tcl_AppendResult)(interp, "1", NULL);
	}
	else
	{
		(*Tcl_AppendResult)(interp, "0", NULL);
	}
	return TCL_OK;
}

int CmdUsersloaded(void *cd,void *interp,int argc,unsigned char *argv[])
{
	if(usersread)
	{
		(*Tcl_AppendResult)(interp, "1", NULL);
	}
	else
	{
		(*Tcl_AppendResult)(interp, "0", NULL);
	}
	return TCL_OK;
}

int CmdIsbot(void *cd,void *interp,int argc,unsigned char *argv[])
{
	char blah[3];

	if (argc!=3)
	{
	  (*Tcl_AppendResult)(interp,"Usage: ", argv[0], " Network BotAddress; returns: 0 if bot isn't found, else returns the bot's flags",NULL);
		return TCL_ERROR;
	}

	(*Tcl_AppendResult)(interp, itoa(isbot(argv[1], argv[2]), blah, 10), NULL);
	return TCL_OK;
}

int CmdIsuser(void *cd,void *interp,int argc,unsigned char *argv[])
{
	char blah[3];

	if (argc!=3)
	{
	  (*Tcl_AppendResult)(interp,"Usage: ", argv[0], " Network UserAddress; returns: 0 if user isn't found, else returns the user's flags",NULL);
		return TCL_ERROR;
	}

	(*Tcl_AppendResult)(interp, itoa(isbot(argv[1], argv[2]), blah, 10), NULL);
	return TCL_OK;
}

int CmdGetpass(void *cd,void *interp,int argc,unsigned char *argv[])
{

	if (argc!=3)
	{
	  (*Tcl_AppendResult)(interp,"Usage: ", argv[0], " Network BotAddress; returns: bot's password or \"\" is bot isn't found",NULL);
		return TCL_ERROR;
	}

	(*Tcl_AppendResult)(interp, getpass(argv[1], argv[2]), NULL);
	return TCL_OK;
}

int CmdUserindex(void *cd,void *interp,int argc,unsigned char *argv[])
{
	int blah;

	if (argc!=3)
	{
	  (*Tcl_AppendResult)(interp,"Usage: ", argv[0], " Network Index",NULL);
		return TCL_ERROR;
	}

	for (blah = 0; argv[2][blah] != '\0'; blah++)
	{
		if(argv[2][blah] < '0' || argv[2][blah] > '9')
		{
			(*Tcl_AppendResult)(interp,"non-numeric value for Index; Usage: ", argv[0], " Network Index",NULL);
			return TCL_ERROR;
		}
	}

	(*Tcl_AppendResult)(interp, userindex(argv[1], atoi(argv[2])), NULL);
	return TCL_OK;
}

int CmdBotindex(void *cd,void *interp,int argc,unsigned char *argv[])
{
	int blah;

	if (argc!=3)
	{
	  (*Tcl_AppendResult)(interp,"Usage: ", argv[0], " Network Index",NULL);
		return TCL_ERROR;
	}

	for (blah = 0; argv[2][blah] != '\0'; blah++)
	{
		if(argv[2][blah] < '0' || argv[2][blah] > '9')
		{
			(*Tcl_AppendResult)(interp,"non-numeric value for Index; Usage: ", argv[0], " Network Index",NULL);
			return TCL_ERROR;
		}
	}

	(*Tcl_AppendResult)(interp, botindex(argv[1], atoi(argv[2])), NULL);
	return TCL_OK;
}

int CmdTotalusers(void *cd,void *interp,int argc,unsigned char *argv[])
{
	char blah[20];

	if (argc!=2)
	{
	  (*Tcl_AppendResult)(interp,"Usage: ", argv[0], " Network",NULL);
		return TCL_ERROR;
	}

	(*Tcl_AppendResult)(interp, itoa(totalusers(argv[1]), blah, 10), NULL);
	return TCL_OK;
}

int CmdTotalbots(void *cd,void *interp,int argc,unsigned char *argv[])
{
	char blah[20];

	if (argc!=2)
	{
	  (*Tcl_AppendResult)(interp,"Usage: ", argv[0], " Network",NULL);
		return TCL_ERROR;
	}

	(*Tcl_AppendResult)(interp, itoa(totalbots(argv[1]), blah, 10), NULL);
	return TCL_OK;
}

int CmdDeluser(void *cd,void *interp,int argc,unsigned char *argv[])
{
	char blah[3];

	if (argc!=3)
	{
	  (*Tcl_AppendResult)(interp,"Usage: ", argv[0], " Network Mask; returns 1 for success and 0 for failure",NULL);
		return TCL_ERROR;
	}

	(*Tcl_AppendResult)(interp, itoa(deluser(argv[1], argv[2], 1), blah, 10), NULL);
	return TCL_OK;
}

int CmdDelbot(void *cd,void *interp,int argc,unsigned char *argv[])
{
	char blah[3];

	if (argc!=3)
	{
	  (*Tcl_AppendResult)(interp,"Usage: ", argv[0], " Network Mask; returns 1 for success and 0 for failure",NULL);
		return TCL_ERROR;
	}

	(*Tcl_AppendResult)(interp, itoa(deluser(argv[1], argv[2], 2), blah, 10), NULL);
	return TCL_OK;
}

int CmdShellExecute(void *cd,void *interp,int argc,unsigned char *argv[])
{
	SHELLEXECUTEINFO sei;
	HINSTANCE H;
	int nShowCmd = SW_SHOW, blah = 0, i;
	char *arg2 = NULL, *arg3 = NULL;
	char *args = NULL, *workdir = NULL, *showtype = NULL;

	if (argc < 2 || argc > 9)
	{
	  (*Tcl_AppendResult)(interp,"Usage: ", argv[0], " Program/File ?-args Arguments? ?-workdir WorkingDirectory? ?-showtype ShowType? ?&?; returns 1 for success and 0 for failure",NULL);
		return TCL_ERROR;
	}

	for(i = 2; i < argc; i++)
	{
		if(!stricmp(argv[i], "-args"))
		{
			if(i + 1 >= argc)
			{
				(*Tcl_AppendResult)(interp,"ERROR: -args used with no arguments to pass. Usage: ", argv[0], " Program/File ?-args Arguments? ?-workdir WorkingDirectory? ?-showtype ShowType? ?&?; returns 1 for success and 0 for failure",NULL);
				return TCL_ERROR;
			}
			i++;
			args = argv[i];
		}
		else
			if(!stricmp(argv[i], "-workdir"))
			{
				if(i + 1 >= argc)
				{
					(*Tcl_AppendResult)(interp,"ERROR: -workdir used with no arguments to pass. Usage: ", argv[0], " Program/File ?-args Arguments? ?-workdir WorkingDirectory? ?-showtype ShowType? ?&?; returns 1 for success and 0 for failure",NULL);
					return TCL_ERROR;
				}
				i++;
				workdir = argv[i];
			}
			else
				if(!stricmp(argv[i], "-showtype"))
				{
					if(i + 1 >= argc)
					{
						(*Tcl_AppendResult)(interp,"ERROR: -showtype used with no arguments to pass. Usage: ", argv[0], " Program/File ?-args Arguments? ?-workdir WorkingDirectory? ?-showtype ShowType? ?&?; returns 1 for success and 0 for failure",NULL);
						return TCL_ERROR;
					}
					i++;
					showtype = argv[i];
				}
				else
					if(!strcmp(argv[i], "&"))
					{
						blah = 1;
					}
					else
					{
						(*Tcl_AppendResult)(interp,"ERROR: unknown switch \"", argv[i], "\". Usage: ", argv[0], " Program/File ?-args Arguments? ?-workdir WorkingDirectory? ?-showtype ShowType? ?&?; returns 1 for success and 0 for failure",NULL);
						return TCL_ERROR;
					}
	}

	if(showtype)
	{
		if(!stricmp("SHOWNORMAL", showtype))
			nShowCmd = SW_SHOWNORMAL;
		else if(!stricmp("SHOWMINIMIZED", showtype))
			nShowCmd = SW_SHOWMINIMIZED;
		else if(!stricmp("SHOWMAXIMIZED", showtype))
			nShowCmd = SW_SHOWMAXIMIZED;
		else if(!stricmp("SHOWNOACTIVATE", showtype))
			nShowCmd = SW_SHOWNOACTIVATE;
		else if(!stricmp("SHOW", showtype))
			nShowCmd = SW_SHOW;
		else if(!stricmp("SHOWMINNOACTIVE", showtype))
			nShowCmd = SW_SHOWMINNOACTIVE;
		else if(!stricmp("SHOWNA", showtype))
			nShowCmd = SW_SHOWNA;
		else if(!stricmp("SHOWDEFAULT", showtype))
			nShowCmd = SW_SHOWDEFAULT;
		else
		{
			(*Tcl_AppendResult)(interp,"invalid value for ShowType; valid values are SHOWNORMAL, SHOWMINIMIZED, SHOWMAXIMIZED, SHOWNOACTIVATE, SHOW, SHOWMINNOACTIVE, SHOWNA, and SHOWDEFAULT",NULL);
			return TCL_ERROR;
		}
	}

	if(!blah)
	{
		sei.cbSize = sizeof(SHELLEXECUTEINFO);
		sei.fMask = SEE_MASK_NOCLOSEPROCESS | SEE_MASK_ICON;
		sei.hwnd = NULL;
		sei.lpVerb = NULL;
		sei.lpFile = argv[1]; 
		sei.lpParameters = args;
		sei.lpDirectory = workdir;
		sei.nShow = nShowCmd;
		sei.hIcon = ExtractIcon(NULL, argv[1], 0);
	
		ShellExecuteEx(&sei);
	
		if ((long)sei.hInstApp <= 32)
		{
			(*Tcl_AppendResult)(interp, "0", NULL);
			// an error occurred
		}
		else
		{
			// wait until the command is done
			WaitForSingleObject(sei.hProcess,INFINITE);
			(*Tcl_AppendResult)(interp, "1", NULL);
		}
	}
	else
	{
		H = ShellExecute(NULL, NULL, argv[1], args, workdir, nShowCmd);

		if((int)H <= 32)
			(*Tcl_AppendResult)(interp, "0", NULL);
		else
			(*Tcl_AppendResult)(interp, "1", NULL);
	}

	return TCL_OK;

}

int CmdReadservers(void *cd,void *interp,int argc,unsigned char *argv[])
{
	char blah[3];

	if (argc!=2)
	{
	  (*Tcl_AppendResult)(interp,"Usage: ", argv[0], " Filename; returns: -1 if Filename cannot be opened, and 1 if read was successful",NULL);
		return TCL_ERROR;
	}

	(*Tcl_AppendResult)(interp, itoa(readservers(argv[1]), blah, 10), NULL);
	return TCL_OK;
}

int CmdClearservers(void *cd,void *interp,int argc,unsigned char *argv[])
{

	if(serversread)
	{
		clear_servers();
		serversread = 0;
		(*Tcl_AppendResult)(interp, "1", NULL);
	}
	else
	{
		(*Tcl_AppendResult)(interp, "0", NULL);
	}
	return TCL_OK;
}

int CmdGetservertype(void *cd,void *interp,int argc,unsigned char *argv[])
{
	int blah;

	if (argc!=3)
	{
	  (*Tcl_AppendResult)(interp,"Usage: ", argv[0], " ServerName ServerPort; returns: network the server is part of or \"\" if server and port aren't found",NULL);
		return TCL_ERROR;
	}
	for (blah = 0; argv[2][blah] != '\0'; blah++)
	{
		if(argv[2][blah] < '0' || argv[2][blah] > '9')
		{
			(*Tcl_AppendResult)(interp,"non-numeric value for ServerPort; Usage: ", argv[0], " <Server Name> <Server Port>",NULL);
			return TCL_ERROR;
		}
	}

	(*Tcl_AppendResult)(interp, get_servertype(argv[1], atoi(argv[2])), NULL);
	return TCL_OK;
}

int CmdIptolong(void *cd,void *interp,int argc,unsigned char *argv[])
{
	int blah;
	unsigned long lip;
	void *bleh = &lip;
	unsigned char *ip1, *ip2, *ip3, *ip4, buf[20], *longip = bleh;
	int i1, i2, i3, i4;

	if (argc!=2)
	{
	  (*Tcl_AppendResult)(interp,"Usage: ", argv[0], " ###.###.###.###; returns: long IP",NULL);
		return TCL_ERROR;
	}
	if(_match("*.*.*.*", argv[1]))
	{
		(*Tcl_AppendResult)(interp,"",NULL);
		return TCL_ERROR;
	}
	for (blah = 0; argv[1][blah] != '\0'; blah++)
	{
		if((argv[1][blah] < '0' || argv[1][blah] > '9') && argv[1][blah] != '.')
		{
			(*Tcl_AppendResult)(interp,"",NULL);
			return TCL_ERROR;
		}
	}
	ip1 = get_token(&argv[1], ".");
	ip2 = get_token(&argv[1], ".");
	ip3 = get_token(&argv[1], ".");
	ip4 = get_token(&argv[1], ".");
	i1 = atoi(ip1);
	i2 = atoi(ip2);
	i3 = atoi(ip3);
	i4 = atoi(ip4);
	if(i1 > 255 || i2 > 255 || i3 > 255 || i4 > 255)
	{
		(*Tcl_AppendResult)(interp,"",NULL);
		return TCL_ERROR;
	}

	*ip1 = atoi(ip1);
	*ip2 = atoi(ip2);
	*ip3 = atoi(ip3);
	*ip4 = atoi(ip4);
	*longip++ = *ip4;
	*longip++ = *ip3;
	*longip++ = *ip2;
	*longip = *ip1;

	(*Tcl_AppendResult)(interp, _ultoa(lip, buf, 10), NULL);
	return TCL_OK;
}

int CmdLongtoip(void *cd,void *interp,int argc,unsigned char *argv[])
{
	int blah;
	unsigned char temp1, temp2, temp3, temp4, *bleh;
	double temp;
	unsigned long longip;
	void *ptrlongip = &longip;
	char outstr[20];

	if (argc!=2)
	{
	  (*Tcl_AppendResult)(interp,"Usage: ", argv[0], " LongIP; returns: IP in ###.###.###.### format",NULL);
		return TCL_ERROR;
	}
	if(strlen(argv[1]) > 10)
	{
		(*Tcl_AppendResult)(interp,"",NULL);
		return TCL_ERROR;
	}
	for (blah = 0; argv[1][blah] != '\0'; blah++)
	{
		if(argv[1][blah] < '0' || argv[1][blah] > '9')
		{
			(*Tcl_AppendResult)(interp,"",NULL);
			return TCL_ERROR;
		}
	}

	temp = atof(argv[1]);
	if(temp > 4294967295)
	{
		(*Tcl_AppendResult)(interp,"",NULL);
		return TCL_ERROR;
	}
	bleh = ptrlongip;
	*bleh++ = '\0';
	*bleh++ = '\0';
	*bleh++ = '\0';
	*bleh++ = '\0';
	longip = strtoul(argv[1], &bleh, 10);
	bleh = ptrlongip;
	temp4 = *bleh++;
	temp3 = *bleh++;
	temp2 = *bleh++;
	temp1 = *bleh++;

	sprintf(outstr, "%u.%u.%u.%u", temp1, temp2, temp3, temp4);

	(*Tcl_AppendResult)(interp, outstr, NULL);
	return TCL_OK;
}

int CmdGetuserlist(void *cd,void *interp,int argc,unsigned char *argv[])
{
	if (argc!=3)
	{
	  (*Tcl_AppendResult)(interp,"Usage: ", argv[0], " Network Mask; TCL list containing all entries that match both <Network> and <Mask>",NULL);
		return TCL_ERROR;
	}
	get_userlist(interp, users, argv[1], argv[2]);
	return TCL_OK;
}

int CmdGetbotlist(void *cd,void *interp,int argc,unsigned char *argv[])
{
	if (argc!=3)
	{
	  (*Tcl_AppendResult)(interp,"Usage: ", argv[0], " Network Mask; TCL list containing all entries that match both <Network> and <Mask>",NULL);
		return TCL_ERROR;
	}
	get_userlist(interp, bots, argv[1], argv[2]);
	return TCL_OK;
}

int CmdIaladd(void *cd,void *interp,int argc,unsigned char *argv[])
{

	if(argc != 4)
	{
	  (*Tcl_AppendResult)(interp,"Usage: ", argv[0], " Nick User@host Channel",NULL);
		return TCL_ERROR;
	}
	if(add_to_ial(interp, argv[1], argv[2], argv[3]))
	{
		(*Tcl_AppendResult)(interp, "1", NULL);
	}
	else
	{
		(*Tcl_AppendResult)(interp, "0", NULL);
	}
	return TCL_OK;
}

int CmdIalremoveglobalchannel(void *cd,void *interp,int argc,unsigned char *argv[])
{

	if(argc != 2)
	{
	  (*Tcl_AppendResult)(interp,"Usage: ", argv[0], " Channel",NULL);
		return TCL_ERROR;
	}
	if(remove_channel_from_ial(interp, argv[1]))
	{
		(*Tcl_AppendResult)(interp, "1", NULL);
	}
	else
	{
		(*Tcl_AppendResult)(interp, "0", NULL);
	}
	return TCL_OK;
}

int CmdIalremovenickchannel(void *cd,void *interp,int argc,unsigned char *argv[])
{

	if(argc != 3)
	{
	  (*Tcl_AppendResult)(interp,"Usage: ", argv[0], " Nick Channel",NULL);
		return TCL_ERROR;
	}
	if(remove_channel_from_ial_nick(interp, argv[1], argv[2]))
	{
		(*Tcl_AppendResult)(interp, "1", NULL);
	}
	else
	{
		(*Tcl_AppendResult)(interp, "0", NULL);
	}
	return TCL_OK;
}

int CmdIalremovenick(void *cd,void *interp,int argc,unsigned char *argv[])
{

	if(argc != 2)
	{
	  (*Tcl_AppendResult)(interp,"Usage: ", argv[0], " Nick",NULL);
		return TCL_ERROR;
	}
	if(delete_ial_user(interp, argv[1]))
	{
		(*Tcl_AppendResult)(interp, "1", NULL);
	}
	else
	{
		(*Tcl_AppendResult)(interp, "0", NULL);
	}
	return TCL_OK;
}

int CmdIalchangenick(void *cd,void *interp,int argc,unsigned char *argv[])
{

	if(argc != 3)
	{
	  (*Tcl_AppendResult)(interp,"Usage: ", argv[0], " Oldnick Newnick",NULL);
		return TCL_ERROR;
	}
	if(change_ial_nick(interp, argv[1], argv[2]))
	{
		(*Tcl_AppendResult)(interp, "1", NULL);
	}
	else
	{
		(*Tcl_AppendResult)(interp, "0", NULL);
	}
	return TCL_OK;
}

int CmdIalclear(void *cd,void *interp,int argc,unsigned char *argv[])
{

	if(argc != 1)
	{
	  (*Tcl_AppendResult)(interp,"Usage: ", argv[0], "",NULL);
		return TCL_ERROR;
	}
	if(delete_ial_interp(interp))
	{
		(*Tcl_AppendResult)(interp, "1", NULL);
	}
	else
	{
		(*Tcl_AppendResult)(interp, "0", NULL);
	}
	return TCL_OK;
}

int CmdIaladdress(void *cd,void *interp,int argc,unsigned char *argv[])
{
	char *retval;

	if(argc != 2)
	{
	  (*Tcl_AppendResult)(interp,"Usage: ", argv[0], " Nick",NULL);
		return TCL_ERROR;
	}
	if((retval = ial_address(interp, argv[1])) == NULL)
		(*Tcl_AppendResult)(interp, "", NULL);
	else
		(*Tcl_AppendResult)(interp, retval, NULL);
	return TCL_OK;
}

int CmdIalison(void *cd,void *interp,int argc,unsigned char *argv[])
{
	if(argc != 3)
	{
	  (*Tcl_AppendResult)(interp,"Usage: ", argv[0], " Nick Channel",NULL);
		return TCL_ERROR;
	}
	if(ial_ison(interp, argv[1], argv[2]))
	{
		(*Tcl_AppendResult)(interp, "1", NULL);
	}
	else
	{
		(*Tcl_AppendResult)(interp, "0", NULL);
	}
	return TCL_OK;
}

int CmdIalnicks(void *cd,void *interp,int argc,unsigned char *argv[])
{
	if(argc != 1)
	{
	  (*Tcl_AppendResult)(interp,"Usage: ", argv[0], NULL);
		return TCL_ERROR;
	}
	ial_nicks(interp);
	return TCL_OK;
}

int CmdGet_token(void *cd,void *interp,int argc,unsigned char *argv[])
{
	char *token, *string = staticwork, *temp;

	if(argc != 3)
	{
	  (*Tcl_AppendResult)(interp,"Usage: ", argv[0], "Varname TokenSeparators", NULL);
		return TCL_ERROR;
	}

	if((temp=(*Tcl_GetVar)(interp, argv[1], TCL_LEAVE_ERR_MSG)) == NULL)
		return TCL_ERROR;

	strcpy(staticwork, temp);

	token = get_token(&string, argv[2]);

	Tcl_SetVar(interp, argv[1], string);
	(*Tcl_Eval)(interp, "");

	if(token)
		(*Tcl_AppendResult)(interp, token, NULL);

	return TCL_OK;
}

int CmdGet_token2(void *cd,void *interp,int argc,unsigned char *argv[])
{
	static char *string = NULL, *token = NULL, *temp;

	if(argc != 4)
	{
	  (*Tcl_AppendResult)(interp,"Usage: ", argv[0], "Varname String TokenSeparators", NULL);
		return TCL_ERROR;
	}

	if(token)
		free(token);

	if(string)
		free(string);

	temp = string = strdup(argv[2]);
	token = get_token(&temp, argv[3]);

	if(token)
		token=strdup(token);
	else
		token = NULL;

	Tcl_SetVar(interp, argv[1], temp);
	(*Tcl_Eval)(interp, "");

	if(token)
		(*Tcl_AppendResult)(interp, token, NULL);

	return TCL_OK;
}

int CmdIdle2str(void *cd,void *interp,int argc,unsigned char *argv[])
{
	int blah;
	char *bleh;
	double temp;
	unsigned long t;

	if (argc!=2)
	{
	  (*Tcl_AppendResult)(interp,"Usage: ", argv[0], " Seconds; returns: amount of time in weeks, days, hours, minutes, and seconds",NULL);
		return TCL_ERROR;
	}

	if(strlen(argv[1]) > 10)
	{
		(*Tcl_AppendResult)(interp,"",NULL);
		return TCL_ERROR;
	}

	for (blah = 0; argv[1][blah] != '\0'; blah++)
	{
		if(argv[1][blah] < '0' || argv[1][blah] > '9')
		{
			(*Tcl_AppendResult)(interp,"",NULL);
			return TCL_ERROR;
		}
	}

	temp = atof(argv[1]);
	if(temp > 4294967295)
	{
		(*Tcl_AppendResult)(interp,"",NULL);
		return TCL_ERROR;
	}

	t = strtoul(argv[1], &bleh, 10);

	(*Tcl_AppendResult)(interp, idle2str(t), NULL);
	return TCL_OK;
}

int CmdIaluserhost(void *cd,void *interp,int argc,unsigned char *argv[])
{
	char *retval;

	if(argc != 2)
	{
	  (*Tcl_AppendResult)(interp,"Usage: ", argv[0], "Nick",NULL);
		return TCL_ERROR;
	}
	if((retval = ial_userhost(interp, argv[1])) == NULL)
		(*Tcl_AppendResult)(interp, "", NULL);
	else
		(*Tcl_AppendResult)(interp, retval, NULL);
	return TCL_OK;
}

int CmdIaluserchannels(void *cd,void *interp,int argc,unsigned char *argv[])
{
	if(argc != 2)
	{
	  (*Tcl_AppendResult)(interp,"Usage: ", argv[0], " Nick",NULL);
		return TCL_ERROR;
	}
	ial_userchannels(interp, argv[1]);
	return TCL_OK;
}

/* callback for initializing DLL */
int __declspec(dllexport) Incubus_Init(void *interp)
{
	if (Tcl_CreateCommand && Tcl_AppendResult && Tcl_AppendElement && Tcl_GetVar && Tcl_Eval)
	{
#ifdef CMD_INI
		(*Tcl_CreateCommand)(interp, "ini", CmdIni, NULL, NULL);
#endif
#ifdef MATCH
		(*Tcl_CreateCommand)(interp, "match", CmdWild_match, NULL, NULL);
#endif
#ifdef CMD_FILEOPEN
		(*Tcl_CreateCommand)(interp, "file_open", Cmdfile_open, NULL, NULL);
#endif
		(*Tcl_CreateCommand)(interp, "strlen", CmdStrlen, NULL, NULL);
		(*Tcl_CreateCommand)(interp, "strcmp", CmdStrcmp, NULL, NULL);
		(*Tcl_CreateCommand)(interp, "strncmp", CmdStrncmp, NULL, NULL);
		(*Tcl_CreateCommand)(interp, "stricmp", CmdStricmp, NULL, NULL);
		(*Tcl_CreateCommand)(interp, "strnicmp", CmdStrnicmp, NULL, NULL);
		(*Tcl_CreateCommand)(interp, "readusers", CmdReadusers, NULL, NULL);
		(*Tcl_CreateCommand)(interp, "writeusers", CmdWriteusers, NULL, NULL);
		(*Tcl_CreateCommand)(interp, "adduser", CmdAdduser, NULL, NULL);
		(*Tcl_CreateCommand)(interp, "addbot", CmdAddbot, NULL, NULL);
		(*Tcl_CreateCommand)(interp, "clear_users", CmdClearusers, NULL, NULL);
		(*Tcl_CreateCommand)(interp, "users_loaded", CmdUsersloaded, NULL, NULL);
		(*Tcl_CreateCommand)(interp, "isbot", CmdIsbot, NULL, NULL);
		(*Tcl_CreateCommand)(interp, "isuser", CmdIsuser, NULL, NULL);
		(*Tcl_CreateCommand)(interp, "getpass", CmdGetpass, NULL, NULL);
		(*Tcl_CreateCommand)(interp, "userindex", CmdUserindex, NULL, NULL);
		(*Tcl_CreateCommand)(interp, "botindex", CmdBotindex, NULL, NULL);
		(*Tcl_CreateCommand)(interp, "totalusers", CmdTotalusers, NULL, NULL);
		(*Tcl_CreateCommand)(interp, "totalbots", CmdTotalbots, NULL, NULL);
		(*Tcl_CreateCommand)(interp, "deluser", CmdDeluser, NULL, NULL);
		(*Tcl_CreateCommand)(interp, "delbot", CmdDelbot, NULL, NULL);
		(*Tcl_CreateCommand)(interp, "shellexecute", CmdShellExecute, NULL, NULL);
		(*Tcl_CreateCommand)(interp, "readservers", CmdReadservers, NULL, NULL);
		(*Tcl_CreateCommand)(interp, "clear_servers", CmdClearservers, NULL, NULL);
		(*Tcl_CreateCommand)(interp, "get_servertype", CmdGetservertype, NULL, NULL);
		(*Tcl_CreateCommand)(interp, "iptolong", CmdIptolong, NULL, NULL);
		(*Tcl_CreateCommand)(interp, "longtoip", CmdLongtoip, NULL, NULL);
		(*Tcl_CreateCommand)(interp, "get_userlist", CmdGetuserlist, NULL, NULL);
		(*Tcl_CreateCommand)(interp, "get_botlist", CmdGetbotlist, NULL, NULL);
#ifdef _IAL_
		(*Tcl_CreateCommand)(interp, "ial_add", CmdIaladd, NULL, NULL);
		(*Tcl_CreateCommand)(interp, "ial_removechannel", CmdIalremoveglobalchannel, NULL, NULL);
		(*Tcl_CreateCommand)(interp, "ial_removenickchannel", CmdIalremovenickchannel, NULL, NULL);
		(*Tcl_CreateCommand)(interp, "ial_removenick", CmdIalremovenick, NULL, NULL);
		(*Tcl_CreateCommand)(interp, "ial_changenick", CmdIalchangenick, NULL, NULL);
		(*Tcl_CreateCommand)(interp, "ial_clear", CmdIalclear, NULL, NULL);
		(*Tcl_CreateCommand)(interp, "address", CmdIaladdress, NULL, NULL);
		(*Tcl_CreateCommand)(interp, "ison", CmdIalison, NULL, NULL);
		(*Tcl_CreateCommand)(interp, "ial_nicks", CmdIalnicks, NULL, NULL);
#endif /* _IAL_ */
		(*Tcl_CreateCommand)(interp, "get_token", CmdGet_token, NULL, NULL);
		(*Tcl_CreateCommand)(interp, "get_token2", CmdGet_token2, NULL, NULL);
		(*Tcl_CreateCommand)(interp, "idle2str", CmdIdle2str, NULL, NULL);
		(*Tcl_CreateCommand)(interp, "ial_userhost", CmdIaluserhost, NULL, NULL);
		(*Tcl_CreateCommand)(interp, "ial_userchannels", CmdIaluserchannels, NULL, NULL);
	}
	else
	{
		FILE *file;
		if((file = fopen("c:\\tclerr.log", "w")) != NULL)
		{
			if(!Tcl_CreateCommand)
				fprintf(file, "Could not get address for Tcl_CreateCommand\n");
			if(!Tcl_AppendResult)
				fprintf(file, "Could not get address for Tcl_AppendResult\n");
			if(!Tcl_AppendElement)
				fprintf(file, "Could not get address for Tcl_AppendElement\n");
			if(!Tcl_GetVar)
				fprintf(file, "Could not get address for Tcl_GetVar\n");
			if(!Tcl_Eval)
				fprintf(file, "Could not get address for Tcl_Eval\n");
			fclose(file);
		}
	}
	return TCL_OK;
}
