#ifndef SERVERS_H
#define SERVERS_H

struct portstruct
{
	int port;
	struct portstruct *next;
} PORTSTRUCT;

typedef struct portstruct *PORT;

struct serverstruct
{
	char *network;
	char *name;
	PORT ports;
	struct serverstruct *next;
} SERVERSTRUCT;

typedef struct serverstruct *SERVER;

SERVER	addserver			(char *, char *);
int		addport				(SERVER , int);
void	parse_serverline	(char *);
int		readservers			(char *);
void	clear_servers		(void);
char	*get_servertype		(char *, int);

#endif /* SERVERS_H */

