#ifndef USERS_H
#define USERS_H

struct userstruct
{
	char *network;
	char *mask;
	int  flags;
	char *password;
	struct userstruct *next;
} USER_STRUCT;

typedef struct userstruct *USER;

void	clear_all_users	(void);
void	adduser			(char *, char *, int, char *);
void	parseline		(char *);
int		read_user_file	(char *);
int		write_user_file	(char *);
int		isbot			(char *, char *);
int		isuser			(char *, char *);
char	*getpass		(char *, char *);
int		totalusers		(char *);
int		totalbots		(char *);
char	*botindex		(char *, int);
char	*userindex		(char *, int);
int		deluser			(char *, char *, int);

#endif